using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace BreadAndCheese {
    /// <summary>
    /// To jest główny typ Twojej gry.
    /// </summary>
    public class BreadAndCheeseGame : Microsoft.Xna.Framework.Game {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // Świat gry
        SpriteFont font;

        struct GameSpriteStruct {
            public Texture2D SpriteTexture;
            public Rectangle SpriteRectangle;
            public float X;
            public float Y;
            public float XSpeed;
            public float X;
            public float WidthFactor;
            public float TicksToCrossScreen;
            public bool Visible;
        }

        GameSpriteStruct cheese;
        GameSpriteStruct bread;
        Texture2D tomatoTexture;
        GameSpriteStruct[] tomatoes;
        int numberOfTomatoes = 20;
        float tomatoHeight;
        float tomatoStepFactor = 0.1f;
        float tomatoHeightLimit;

        // Dane o postępie gry
        int score;
        int lives;

        void setupTomatoes() {
            tomatoHeight = minDisplayY;
            tomatoHeightLimit = minDisplayY + ((maxDisplayY - minDisplayY) / 2);
            tomatoes = new GameSpriteStruct[numberOfTomatoes];

            float tomatoSpacing = (maxDisplayX - minDisplayX) / numberOfTomatoes;

            for (int i = 0; i < numberOfTomatoes; i++) {
                tomatoes[i].SpriteTexture = tomatoTexture;
                setupSprite(
                        ref tomatoes[i],
                        0.05f, // 20 pomidorów na całym ekranie
                        1000, // 1000 taktów na pokonanie całego ekranu
                        minDisplayX + (i * tomatoSpacing), minDisplayY,
                        true // początkowo sprajty są widoczne
                        );
            }
        }

        void setupSprites() {
            score = 0;
            lives = 3;

            setupSprite(ref cheese, 0.05f, 200.0f, 200, 100, true);
            setupSprite(ref bread, 0.15f, 120.0f, displayWidth / 2, displayHeight / 2, true);

            setupTomatoes();
        }

        // Ustawienia ekranu
        float displayWidth;
        float displayHeight;
        float overScanPercentage = 10.0f;
        float minDisplayX;
        float maxDisplayX;
        float minDisplayY;
        float maxDisplayY;

        float getPercentage(float percentage, float inputValue) {
            return (inputValue * percentage) / 100;
        }

        void setupSprite(
                ref GameSpriteStruct sprite,
                float widthFactor,
                float ticksToCrossScreen,
                float initialX,
                float initialY,
                bool initialVisibility) {
            sprite.WidthFactor = widthFactor;
            sprite.TicksToCrossScreen = ticksToCrossScreen;
            sprite.SpriteRectangle.Width = (int) ((displayWidth * widthFactor) + 0.5f);
            float aspectRatio =
                    (float) sprite.SpriteTexture.Width / sprite.SpriteTexture.Height;
            sprite.SpriteRectangle.Height =
                    (int) ((sprite.SpriteRectangle.Width / aspectRatio) + 0.5f);
            sprite.X = initialX;
            sprite.Y = initialY;
            sprite.XSpeed = displayWidth / ticksToCrossScreen;
            sprite.YSpeed = sprite.XSpeed;
            sprite.Visible = initialVisibility;
        }

        void resetTomatoDisplay() {
            tomatoHeight = tomatoHeight + (displayHeight * tomatoStepFactor);

            if (tomatoHeight > tomatoHeightLimit) {
                tomatoHeight = minDisplayY;
            }

            for (int i = 0; i < numberOfTomatoes; i++) {
                tomatoes[i].Visible = true;
                tomatoes[i].Y = tomatoHeight;
            }
        }

        private void setupScreen() {
            displayWidth = graphics.GraphicsDevice.Viewport.Width;
            displayHeight = graphics.GraphicsDevice.Viewport.Height;
            float xOverscanMargin = getPercentage(overScanPercentage, displayWidth) / 2.0f;
            float yOverscanMargin = getPercentage(overScanPercentage, displayHeight) / 2.0f;

            minDisplayX = xOverscanMargin;
            minDisplayY = yOverscanMargin;

            maxDisplayX = displayWidth - xOverscanMargin;
            maxDisplayY = displayHeight - yOverscanMargin;
        }

        void drawText(string text, Color textColor, float x, float y) {
            int layer;
            Vector2 textVector = new Vector2(x, y);

            // Rysuje cień
            Color backColor = new Color(0, 0, 0, 20);
            for (layer = 0; layer < 10; layer++) {
                spriteBatch.DrawString(font, text, textVector, backColor);
                textVector.X++;
                textVector.Y++;
            }

            // Rysuje podstawę znaków
            backColor = new Color(190, 190, 190);
            for (layer = 0; layer < 5; layer++) {
                spriteBatch.DrawString(font, text, textVector, backColor);
                textVector.X++;
                textVector.Y++;
            }

            // Rysuje przednią część znaków
            spriteBatch.DrawString(font, text, textVector, textColor);
        }

        public BreadAndCheeseGame() {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Umożliwia ewentualną inicjalizację przed uruchomieniem właściwej gry.
        /// W tym miejscu można odnaleźć wszystkie wymagane zasoby i załadować treści
        /// related content. Wywołanie metody base.Initialize spowoduje przeszukanie wszystkich komponentów
        /// i ich inicjalizację.
        /// </summary>
        protected override void Initialize() {
            setupScreen();

            base.Initialize();
        }

        /// <summary>
        /// Metoda LoadContent jest wywoływana tylko raz dla całej gry i jako taka jest właściwym miejscem
        /// dla kodu ładującego treść.
        /// </summary>
        protected override void LoadContent() {
            // Tworzy nowy obiekt klasy SpriteBatch, którego można używać do rysowania tekstur.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            cheese.SpriteTexture = Content.Load<Texture2D > ("Images/Cheese");
            bread.SpriteTexture = Content.Load<Texture2D > ("Images/Bread");
            tomatoTexture = Content.Load<Texture2D > ("Images/Tomato");
            font = Content.Load<SpriteFont > ("SpriteFont1");

            setupSprites();
        }

        /// <summary>
        /// Metoda UnloadContent jest wywoływana tylko raz dla całej gry i jako taka jest właściwym miejscem
        /// dla kodu usuwającego całą treść z pamięci.
        /// </summary>
        protected override void UnloadContent() {
            // TODO: Należy usunąć całą treść, którą nie zarządza ContentManager.
        }

        /// <summary>
        /// Umożliwia grze wykonywanie logiki związanej z aktualizacją świata gry,
        /// sprawdzaniem kolizji, pobieraniem danych wejściowych czy odtwarzaniem dźwięków.
        /// </summary>
        /// <param name="gameTime">Udostępnia wartości reprezentujące bieżący czas.</param>
        protected override void Update(GameTime gameTime) {
            GamePadState gamePad1 = GamePad.GetState(PlayerIndex.One);
            // Pozwala opuścić grę
            if (gamePad1.Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // Ruch sprajtu sera

            cheese.X = cheese.X + cheese.XSpeed;
            cheese.Y = cheese.Y + cheese.YSpeed;
            cheese.SpriteRectangle.X = (int) (cheese.X + 0.5f);
            cheese.SpriteRectangle.Y = (int) (cheese.Y + 0.5f);

            if (cheese.X + cheese.SpriteRectangle.Width >= maxDisplayX) {
                cheese.XSpeed = Math.Abs(cheese.XSpeed) * -1;
            }

            if (cheese.X <= minDisplayX) {
                cheese.XSpeed = Math.Abs(cheese.XSpeed);
            }

            if (cheese.Y + cheese.SpriteRectangle.Height >= maxDisplayY) {
                cheese.YSpeed = Math.Abs(cheese.YSpeed) * -1;
                if (lives > 0) {
                    lives--;
                }
            }

            if (cheese.Y <= minDisplayY) {
                cheese.YSpeed = Math.Abs(cheese.YSpeed);
            }

            if (lives <= 0) {
                return;
            }

            // Ruch chleba

            bread.X = bread.X + (bread.XSpeed * gamePad1.ThumbSticks.Left.X);
            bread.Y = bread.Y - (bread.YSpeed * gamePad1.ThumbSticks.Left.Y);
            bread.SpriteRectangle.X = (int) bread.X;
            bread.SpriteRectangle.Y = (int) bread.Y;

            if (bread.SpriteRectangle.Intersects(cheese.SpriteRectangle)) {
                cheese.YSpeed = cheese.YSpeed * -1;
            }

            // Aktualizuje stan pomidorów.
            bool noTomatoes = true;

            for (int i = 0; i < numberOfTomatoes; i++) {
                if (tomatoes[i].Visible) {
                    noTomatoes = false;
                    if (cheese.SpriteRectangle.Intersects(tomatoes[i].SpriteRectangle)) {
                        cheese.YSpeed = cheese.YSpeed * -1;
                        score = score + 10;
                        tomatoes[i].Visible = false;
                        break;
                    }
                }

                tomatoes[i].SpriteRectangle.X = (int) tomatoes[i].X;
                tomatoes[i].SpriteRectangle.Y = (int) tomatoes[i].Y;
            }

            if (noTomatoes) {
                resetTomatoDisplay();
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Ta metoda jest wywoływana w momencie, w którym gra musi narysować swój świat.
        /// </summary>
        /// <param name="gameTime">Udostępnia wartości reprezentujące bieżący czas.</param>
        protected override void Draw(GameTime gameTime) {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            spriteBatch.Draw(cheese.SpriteTexture, cheese.SpriteRectangle, Color.White);
            spriteBatch.Draw(bread.SpriteTexture, bread.SpriteRectangle, Color.White);

            for (int i = 0; i < numberOfTomatoes; i++) {
                if (tomatoes[i].Visible) {
                    spriteBatch.Draw(tomatoes[i].SpriteTexture,
                            tomatoes[i].SpriteRectangle, Color.White);
                }
            }

            drawText(
                    "Wynik: " + score.ToString() + " Życia: " + lives.ToString(),
                    Color.White,
                    minDisplayX,
                    maxDisplayY - 50);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
